class PGraph:
  def __init__(self):
    self.seed = 1
    self.pList = []
#    self.aList = dict()
    
  def add(self, id1, id2):
    pList = self.pList
  
    # create new entries if they dont exist
    p1 = p2 = False
    for p in pList:
      if p[0] == id1: p1 = p
      if p[0] == id2: p2 = p
    if not p1:
      p1 = [id1, [], []]
      pList.append(p1)
    if not p2:
      p2 = [id2, [], []]
      pList.append(p2)

    if not p2 in p1[1]:
      p1[1].append(p2) # next (downstream)
    if not p1 in p2[2]:
      p2[2].append(p1) # prev (upstream)
      
  def upstream(self, key, depth=0, stop=[]):
    return self.traverse(key, 2, depth, stop)

  def downstream(self, key, limit=0, stop=[]):
    return self.traverse(key, 1, limit, stop)

  def traverse(self, key, direction, limit=0, stop=[]):
    """ limit and stop conditions, perform
        transitive closure using a bottom-up search """
    pList = self.pList
    # find node
    p = False
    for pp in pList:  
      if pp[0] == key:
        p = pp
        break
    if not p:
      return []
    # calc closure
    result = []
    base = [p]
    nextbase = []
    while base != []:# and depth != limit:
      b = base.pop(0) # bottom-up
      if b[0] in stop:
        continue
      for d in b[direction]: # next/prev
        exist = processed = False
        for r in result:
          if r[1] == d[0]:
            processed = True
            if r[0] == d[0]:
              exist = True
        if not exist:
          if direction == 1:
            result.append([b[0], d[0]])
          else:
            result.append([d[0], b[0]])
        if not processed:# and d[0].depth != 1:        
# d[0].depth = b[0].depth - 1
          nextbase.append(d)
        if base == []:
#          depth = depth + 1
          base = nextbase
          nextbase = []
    return result

