from pTypes import *
import PQueryInterface

class PQObject:
  def __init__(self, pqf, ptype, pid, ns):
    " Sets PQueryFactory, id, type "
    self.pqf = pqf
    self.pid = pId(pid, ns)
    self.ptype = ptype
  n = 0
  
  def __eq__(self, other):
    " Compares nodes by considering alias "  
#    return self.pqf.equals(self, other)
    return self.pid == other.pid
  '''
  def get(self, ptype):
    " handles all kinds of queries using ptype relations "
    return self.pqf.get(self, ptype)
  ''' 

  #### query wrappers ####

  def exist(self):
    " determines if the node exist in the source "
    return True # in self.get(self.ptype)

  def upstream(self, limit = 0, stop = []):
    """ returns all ancestors of the transitive
        upstream relation in a bottom-up search """
    return self.pqf.traverse(False, self, limit, stop)

  def downstream(self, limit = 0, stop = []):
    """ returns all ancestors of the transitive
        upstream relation in a bottom-up search """
    return self.pqf.traverse(self, False, limit, stop)

  def related(self, node, limit = 0, stop = []):
    """ checks if two nodes are related """
    return self.pqf.related(self, node, limit, stop)
  '''  
  def traverse(self, ptype):
    """ using a transitive relation to perform
        transitive closure using a bottom-up search """
    result = []    
    base = [self]
    while base != []:
      b = base.pop(0) # bottom-up
      for d in b.get(ptype):
        exist = processed = False
        for r in result:
          if r[1].pid.key == d.pid.key and r[1].pid.ns == d.pid.ns:
            processed = True
            if r[0].pid.key == d.pid.key and r[0].pid.ns == d.pid.ns:
              exist = True
        if not exist:
          result.append([b, d])
        if not processed:        
          base.append(d)
    return result
  '''

  ############ api passthroughs ########## 
  
  ## execution section ##
  def getDataFromOutPort(self):
    return self.pqf.getDataFromOutPort(self) 

  def getOutPortFromData(self):
    return self.pqf.getOutPortFromData(self) 

  def getDataFromInPort(self):
    return self.pqf.getDataFromInPort(self) 

  def getInPortFromData(self):
    return self.pqf.getInPortFromData(self) 

  def getExecutionFromInData(self):
    return self.pqf.getExecutionFromInData(self) 

  def getInDataFromExecution(self):
    return self.pqf.getInDataFromExecution(self) 

  def getExecutionFromOutData(self):
    return self.pqf.getExecutionFromOutData(self) 

  def getOutDataFromExecution(self):
    return self.pqf.getOutDataFromExecution(self) 

  def getInstanceFromExecution(self):
    return self.pqf.getInstanceFromExecution(self) 

  def getExecutionFromInstance(self):
    return self.pqf.getExecutionFromInstance(self) 

  def getRunFromExecution(self):
    return self.pqf.getRunFromExecution(self) 

  def getExecutionFromRun(self):
    return self.pqf.getExecutionFromRun(self) 

  def getRunFromWorkflow(self):
    return self.pqf.getRunFromWorkflow(self) 

  def getWorkflowFromRun(self):
    return self.pqf.getWorkflowFromRun(self) 

  def getInstanceFromWorkflow(self):
    return self.pqf.getInstanceFromWorkflow(self) 

  def getWorkflowFromInstance(self):
    return self.pqf.getWorkflowFromInstance(self) 

  def getParentDataItem(self):
    return self.pqf.getParentDataItem(self) 

  def getChildDataItem(self):
    return self.pqf.getChildDataItem(self) 

  def getParentExecution(self):
    return self.pqf.getParentExecution(self) 

  def getChildExecution(self):
    return self.pqf.getChildExecution(self) 

  ## workflow part ##
  def getModuleFromInstance(self):
    return self.pqf.getModuleFromInstance(self) 

  def getInstanceFromModule(self):
    return self.pqf.getInstanceFromModule(self) 

  def getStartConnectionFromInstance(self):
    return self.pqf.getStartConnectionFromInstance(self) 

  def getEndConnectionFromInstance(self):
    return self.pqf.getEndConnectionFromInstance(self) 
  
  def getStartInstanceFromConnection(self):
    return self.pqf.getStartInstanceFromConnection(self) 
  
  def getEndInstanceFromConnection(self):
    return self.pqf.getEndInstanceFromConnection(self) 
  
  def getConnectionFromWorkflow(self):
    return self.pqf.getConnectionFromWorkflow(self) 
  
  def getWorkflowFromConnection(self):
    return self.pqf.getWorkflowFromConnection(self) 
  
  def getParentWorkflow(self):
    return self.pqf.getParentWorkflow(self) 
  
  def getChildWorkflow(self):
    return self.pqf.getChildWorkflow(self) 
  
  def getConnectionFromInPort(self):
    return self.pqf.getConnectionFromInPort(self) 
  
  def getInPortFromConnection(self):
    return self.pqf.getInPortFromConnection(self) 
  
  def getConnectionFromOutPort(self):
    return self.pqf.getConnectionFromOutPort(self) 
  
  def getOutPortFromConnection(self):
    return self.pqf.getOutPortFromConnection(self) 
  
  ## module section ##
  def getOutPortFromModule(self):
    return self.pqf.getOutPortFromModule(self) 

  def getInPortFromModule(self):
    return self.pqf.getInPortFromModule(self) 

  def getModuleFromOutPort(self):
    return self.pqf.getModuleFromOutPort(self) 

  def getModuleFromInPort(self):
    return self.pqf.getModuleFromInPort(self)
    
  ## special section ##
  def getAnnotation(self):
    return self.pqf.getAnnotation(self) 

