import PStore, PQObject, libxml2, sparql

class RDFStore(PStore.PStore):
  " RDF specific store base class "
  def __init__(self, ns, path, xmlns = dict()):
    " Loads source, creates context and sets ns:s"
    PStore.PStore.__init__(self)

    self.processor = 'http://localhost:2020/sparql'    

    self.alias = dict()
    self.ns = ns
    self.path = path
    self.service = sparql.Service(self.processor)
    for p, u in xmlns.iteritems():
      self.service.setPrefix(p, u)
    self.context = self.service.createQuery()

  def processQueryAsList(self, q, ptype):
    dataitems = self.context.query(q)
    newdataitems = []
    for (d,) in dataitems:
      newdataitems.append(PQObject.PQObject(self.pqf, ptype, d, self.ns))
    return newdataitems

  def processQueryAsPairList(self, q, ptype):
    dataitems = self.context.query(q)
    newdataitems = []
    for (d,e) in dataitems:
      newdataitems.append([PQObject.PQObject(self.pqf, ptype, d, self.ns), PQObject.PQObject(self.pqf, ptype, e, self.ns)])
    return newdataitems

  def processQueryAsDict(self, q):
    dataitems = self.context.query(q)
    newdataitems = dict()
    for (d,e) in dataitems:
      newdataitems[d] = e
    return newdataitems

      # http://localhost:2020/sparql?query=select%20?a%20from%20<webapps/joseki/SecondChallenge_myGrid_Part1.rdf>%20where%20{%20?a%20?b%20?c%20}
      # http://localhost:2020/sparql?query=select%20?a%20from%20<http://twiki.ipaw.info/pub/Challenge/MyGrid2/SecondChallenge_myGrid_Part1.rdf>%20where%20{%20?a%20?b%20?c%20}
      # http://twiki.ipaw.info/pub/Challenge/MyGrid2/SecondChallenge_myGrid_Part1.rdf
