from pTypes import *
import XMLStore

class TavernaStore(XMLStore.XMLStore):
  def __init__(self, name, path):
    " Adds Taverna ns:s and calls XMLStore constructor "
    self.name = name
    xmlns = dict()
    xmlns['myg'] = "http://www.mygrid.org.uk/provenance#"
    xmlns['rdf'] = "http://www.w3.org/1999/02/22-rdf-syntax-ns#"
    XMLStore.XMLStore.__init__(self, 'taverna', path, xmlns)

  #### relations implemented #### 
  def exist(self, node):
    " determines if the node exist in the source "
    q = 'local-name(//*[@rdf:about="' + node.pid.key + '"])'
    return self.context.xpathEval(q) != []
  
  def derivedFrom(self, node):
    " returns all data that contributed directly "
    q = '//*[@rdf:about="' + node.pid.key + '"]/myg:dataDerivedFrom/@rdf:resource'
    return self.processQueryAsList(q)

  def outputHasData(self, node):
    "  "
    q = '//*[./myg:outputDataHasName/@rdf:resource="' + node.pid.key + '"]/@rdf:about'
    return self.processQueryAsList(q)

  def getModuleExecutionFromData(self, node):
    "  "
    q = '//*[./myg:processOutput/@rdf:resource="' + node.pid.key + '"]/@rdf:about'
    return self.processQueryAsList(q)

  def derivedData(self, node):
    "returns all data that contributed directly"
    q = '//*[myg:dataDerivedFrom[@rdf:resource="' + node.pid.key + '"]]/@rdf:about'
    return self.processQueryAsList(q)

