import PQueryFactory, VisTrailsStore, TavernaRDFStore, PasoaStore
from pTypes import *

pqf = PQueryFactory.PQueryFactory()

store1 = TavernaRDFStore.TavernaRDFStore('myg1', 'data/SecondChallenge_myGrid_Part1.rdf')
store2 = PasoaStore.PasoaStore('pas2', '../Southampton/part1-2.xml')
store3 = VisTrailsStore.VisTrailsStore('vt3', '../VisTrails/pc_part3a.xml')
pqf2 = PQueryFactory.PQueryFactory()
store3b = VisTrailsStore.VisTrailsStore('vt3', '../VisTrails/pc_part3b.xml')
pqf2.addStore(store3b)

# get names of process runs
reslice1run = pId('urn:www.mygrid.org.uk/process_run#1171562616279', store1.ns)
reslice2run = pId('urn:www.mygrid.org.uk/process_run#1171562615764', store1.ns)
reslice3run = pId('urn:www.mygrid.org.uk/process_run#1171562616029', store1.ns)
reslice4run = pId('urn:www.mygrid.org.uk/process_run#1171562616701', store1.ns)
softmeanrun = pId('470', store2.ns)
slicer1run = pId('41', store3.ns)

# add connections between sources
store1.addConn(reslice1run, softmeanrun).addConn(reslice2run, softmeanrun)
store1.addConn(reslice3run, softmeanrun).addConn(reslice4run, softmeanrun)
store2.addConn(reslice1run, softmeanrun).addConn(reslice2run, softmeanrun)
store2.addConn(reslice3run, softmeanrun).addConn(reslice4run, softmeanrun)
store2.addConn(softmeanrun, slicer1run)
store3.addConn(softmeanrun, slicer1run)

pqf.addStore(store1)
pqf.addStore(store2)
pqf.addStore(store3)

print '''
*************
*** start ***
*************
'''

print 'query 1'
r2 = pqf.getAllAnnotated(pModuleInstance,[('outputName', 'eq', 'atlas-x.gif')])
for i, i2 in r2[0].getExecutionFromInstance()[0].upstream():
    print i.pid.ns + ":" + i.getInstanceFromExecution()[0].pid.key + ' --> ' + i2.pid.ns + ":" + i2.getInstanceFromExecution()[0].pid.key


print 'query 2'
r2 = pqf.getAllAnnotated(pModuleInstance,[('outputName', 'eq', 'atlas-x.gif')])
smExec = pqf.getNode(pModuleInstance, 'http://relation.org/softmean', store2.ns).getExecutionFromInstance()[0].pid.key
for i, i2 in r2[0].getExecutionFromInstance()[0].upstream(0, [smExec]):
    print i.pid.ns + ":" + i.getInstanceFromExecution()[0].pid.key + ' --> ' + i2.pid.ns + ":" + i2.getInstanceFromExecution()[0].pid.key

# query 3 not implemented because stage information is not available

print 'query 4'
ar = [('http://www.mygrid.org.uk/provenance#endTime', 'weekday', 'th'),
      ('urn:www.mygrid.org.uk/process#Parameter', 'in', '-m 12')]
wel = pqf.getAllAnnotated(pModuleExecution, ar)
for we in wel:
  print we.getInstanceFromExecution()[0].pid.key


print 'query 5' 

ar = [('http://www.mygrid.org.uk/provenance#global', 'in', '4095')]
wflist = []
for di in pqf.getAllAnnotated(pDataItem, ar):
  for we in di.getExecutionFromOutData():
    wf = we.getRunFromExecution()[0]
    if wf not in wflist:
      wflist.append(wf)
for wf in wflist:
  mil = []
  for mi in wf.getExecutionFromRun()[1].downstream():
    if mi[1] not in mil:
      mil.append(mi[1])
      a = mi[1].getInstanceFromExecution()[0].getAnnotation()
      if a.has_key('outputName'):
        print a['outputName']
 

print 'query 6'
ar = [('urn:www.mygrid.org.uk/process#Parameter', 'in', '-m 12')]
wel = pqf.getAllAnnotated(pModuleExecution, ar)[0].downstream()
r = []
for [e1, e2] in wel:
  softmean = 'http://relation.org/softmean'
  if e1.getInstanceFromExecution()[0].pid.key  == softmean:
    for d in e1.getOutDataFromExecution():
      if not d in r: r.append(d)
for d in r:
  print d.pid.key


print 'query 7'
pqf2 = PQueryFactory.PQueryFactory()
store3b = VisTrailsStore.VisTrailsStore('vt3b', '../VisTrails/pc_part3b.xml')
pqf2.addStore(store3b)
i1l = store3.getAll(pModule)
i2l = store3b.getAll(pModule)
diff_list = []
for i1 in i1l:
  found = False
  for i2 in i2l:
    if i1.pid.key == i2.pid.key:
      found = True
  if found == False:
    if i1 not in diff_list:
      diff_list.append(i1)

for i2 in i2l:
  found = False
  for i1 in i1l:
    if i2.pid.key == i1.pid.key:
      found = True
  if found == False:
    if i2 not in diff_list:
      diff_list.append(i2)

for item in diff_list:
  print item.pid.ns + ':' + item.pid.key




print 'query 8'
ar = [('http://www.mygrid.org.uk/provenance#center', 'in', 'UChicago')]
r = pqf.getAllAnnotated(pDataItem, ar)
for d in r:
  print d.pid.key


print 'query 9'
# !!! there are no annotations in the data! Does not work!!!!!
rr = []
ar = [('http://www.mygrid.org.uk/provenance#studyModality', 'in', 'speech')]
r1 = pqf.getAllAnnotated(pDataItem, ar)
for r in r1: rr.append(r)
ar = [('http://www.mygrid.org.uk/provenance#studyModality', 'in', 'visual')]
r2 = pqf.getAllAnnotated(pDataItem, ar)
for r in r2: rr.append(r)
ar = [('http://www.mygrid.org.uk/provenance#studyModality', 'in', 'audio')]
r3 = pqf.getAllAnnotated(pDataItem, ar)
for r in r2: rr.append(r)

for d in rr:
  print d.pid.key[-8:]
  for (k, v) in d.get(pAnnotation).iteritems():
    print ' ', k.split('#')[1], '=', v


print '''
***********
*** end ***
***********
'''
