import PQueryFactory, VisTrailsStore
from pTypes import *

pqf = PQueryFactory.PQueryFactory()

store1 = VisTrailsStore.VisTrailsStore('vt1', '../VisTrails/pc_part1.xml')
store2 = VisTrailsStore.VisTrailsStore('vt2', '../VisTrails/pc_part2.xml')
store3 = VisTrailsStore.VisTrailsStore('vt3', '../VisTrails/pc_part3a.xml')

pqf.addStore(store1)
pqf.addStore(store2)
pqf.addStore(store3)

# Calculate bridging using file names

# find all (F)ile(S)(e)t and (S)(i)nk instances in all sources with file names
fseList = []
fsiList = []
for s in pqf.store.itervalues():
  for fse in pqf.getNode(pModule, 'FileSet', s.ns).getInstanceFromModule():
    fse.baseName = fse.getAnnotation()['baseName']
    fseList.append(fse)
  for fsi in pqf.getNode(pModule, 'FileSetSink', s.ns).getInstanceFromModule():
    fsi.outputBaseName = fsi.getAnnotation()['outputBaseName']
    fsiList.append(fsi)
# join them using filename and add the result to store connections

for fse in fseList:
  for fsi in fsiList:
    if fsi.outputBaseName == fse.baseName:
      pqf.store[fsi.pid.ns].addConn(fsi.pid, fse.pid)
      pqf.store[fse.pid.ns].addConn(fsi.pid, fse.pid)
  
print '''
*************
*** start ***
*************
'''
'''
# query 1,2,3

#r1 = pqf.getNode(pModule, 'FileSink', store3.ns).getInstanceFromModule()
ar = [('outputName', 'eq', 'atlas-x.gif')]
r2 = pqf.getAllAnnotated(pModuleInstance,ar)

#for i, i2 in pqf.pAnd(r1,r2)[0].upstream():
for i, i2 in r2[0].upstream():
  print i.getModuleFromInstance()[0].pid.key + ':' + i.pid.key, "--> ", i2.getModuleFromInstance()[0].pid.key + ':' + i2.pid.key
#  for a,b in i.getAnnotation().iteritems():
#    print ' ', a, "=", b
'''

# query 4

'''
aw = pqf.getNode(pModule, 'AlignWarp', store1.ns)

mil = aw.getInstanceFromModule()
mel =  []
for mi in mil:
  if mi.getAnnotation()['model'] == '12':
    for me in mi.getExecutionFromInstance():
      mel.append(me)
for me in mel:
  if pqf.store[me.pid.ns].dayOfWeek(me.getAnnotation()['tsStart'], 'we'):
    print me.pid.key
'''

# query 5 

ar = [('global maximum', 'eq', '4095')]
wflist = []
for we in pqf.getAllAnnotated(pModuleExecution, ar):
  wf = we.getRunFromExecution()[0].getWorkflowFromRun()[0]
  if wf not in wflist:
    wflist.append(wf)

for wf in wflist:
  mil = []
  for mi in wf.getInstanceFromWorkflow()[0].downstream():
    if mi[1] not in mil:
      mil.append(mi[1])
      a = mi[1].getAnnotation()
      if a.has_key('outputName'):
        print a['outputName']
  
# query 6
'''
intermediate data items not recorded in VisTrails
'''

# query 8
'''
ar = [('http://www.mygrid.org.uk/provenance#center', 'in', 'UChicago')]
r = pqf.getAllAnnotated(pDataItem, ar)
for d in r:
  print 'Dataitem found:', d.pid.key[-8:]
'''
# query 9
'''
rr = []
ar = [('http://www.mygrid.org.uk/provenance#studyModality', 'in', 'speech')]
r1 = pqf.getAllAnnotated(pDataItem, ar)
for r in r1: rr.append(r)
ar = [('http://www.mygrid.org.uk/provenance#studyModality', 'in', 'visual')]
r2 = pqf.getAllAnnotated(pDataItem, ar)
for r in r2: rr.append(r)
ar = [('http://www.mygrid.org.uk/provenance#studyModality', 'in', 'audio')]
r3 = pqf.getAllAnnotated(pDataItem, ar)
for r in r2: rr.append(r)

for d in rr:
  print d.pid.key[-8:]
  for (k, v) in d.get(pAnnotation).iteritems():
    print ' ', k.split('#')[1], '=', v
'''
  
print '''
***********
*** end ***
***********
'''
